﻿B4R=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=3.71
@EndOfDesignText@


Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'Public variables can be accessed from all modules.

	Private quotearray() As Byte = """"
	Private lastIndex As Long
End Sub



#Region JSONParse

Sub GetTextValueFromKey (json() As Byte, Key() As Byte, StartIndex As Int, ResultBuffer() As Byte, MaxLength As UInt)
	Dim bc As ByteConverter
	Dim qkey() As Byte = JoinBytes(Array(quotearray, Key, quotearray))
	Dim i As Int = bc.IndexOf2(json, qkey, StartIndex)
	If i = -1 Then
		bc.ArrayCopy(Array As Byte(), ResultBuffer)
		Return
	End If
	Dim i1 As Int = bc.IndexOf2(json, quotearray, i + qkey.Length + 1)
	Dim i2 As Int = bc.IndexOf2(json, quotearray, i1 + 1)
	bc.ArrayCopy(bc.SubString2(json, i1 + 1, Min(i2, i1 + 1 + MaxLength)), ResultBuffer)
	lastIndex = i2
End Sub


Sub GetNumberValueFromKey (json() As Byte, Key() As Byte, StartIndex As Int) As Double
	Dim bc As ByteConverter
	Dim qkey() As Byte = JoinBytes(Array(quotearray, Key, quotearray))
	Dim i As Int = bc.IndexOf2(json, qkey, StartIndex)
	If i = -1 Then Return 0
	Dim colon As Int = bc.IndexOf2(json, ":", i + qkey.Length)
	Dim i2 As Int = 0
	For Each c As String In Array As String(",", "}", "]")
		i2 = bc.IndexOf2(json, c, colon + 1)
		If i2 <> -1 Then
			Exit
		End If
	Next
	Dim res() As Byte = bc.SubString2(json, colon + 1, i2)
	lastIndex = i2 + 1
	res = bc.Trim(res)
	Dim s As String = bc.StringFromBytes(res)
	Dim value As Double = s
	Return value
End Sub

#End Region
